"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var auth_1 = require("./utils/auth");
/** Create redux actions to be dispatched by connected components, mostly
    to make requests to the server. */
var ActionCreator = /** @class */ (function () {
    function ActionCreator(fetcher) {
        this.fetcher = fetcher;
    }
    ActionCreator.prototype.fetchBlob = function (type, url) {
        var _this = this;
        return function (dispatch) { return __awaiter(_this, void 0, void 0, function () {
            var response, blob, newResp, blob, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dispatch(this.request(type, url));
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 8, , 9]);
                        return [4 /*yield*/, this.fetcher.fetch(url)];
                    case 2:
                        response = _a.sent();
                        if (!response.ok) return [3 /*break*/, 4];
                        return [4 /*yield*/, response.blob()];
                    case 3:
                        blob = _a.sent();
                        dispatch(this.success(type));
                        return [2 /*return*/, blob];
                    case 4:
                        if (!response.redirected) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.fetcher.fetch(response.url, {
                                headers: { Authorization: "" }
                            })];
                    case 5:
                        newResp = _a.sent();
                        return [4 /*yield*/, newResp.blob()];
                    case 6:
                        blob = _a.sent();
                        if (newResp.ok) {
                            dispatch(this.success(type));
                            return [2 /*return*/, blob];
                        }
                        console.error("Original Response ", response);
                        console.error("New Response ", newResp);
                        throw {
                            status: 500,
                            response: "Retried fetch after redirect. The retry did not succeed.",
                            url: url
                        };
                    case 7:
                        console.error("Response: ", response);
                        throw {
                            status: 500,
                            url: url,
                            response: "Response was not okay and was not retried (wasn't the result of a redirect)."
                        };
                    case 8:
                        e_1 = _a.sent();
                        dispatch(this.failure(type, e_1));
                        throw e_1;
                    case 9: return [2 /*return*/];
                }
            });
        }); };
    };
    ActionCreator.prototype.fetchJSON = function (type, url) {
        var _this = this;
        var err;
        return function (dispatch) {
            return new Promise(function (resolve, reject) {
                dispatch(_this.request(type, url));
                _this.fetcher
                    .fetch(url)
                    .then(function (response) {
                    if (response.ok) {
                        response
                            .json()
                            .then(function (data) {
                            dispatch(_this.success(type));
                            dispatch(_this.load(type, data));
                            resolve(data);
                        })
                            .catch(function (parseError) {
                            err = {
                                status: response.status,
                                response: "Non-json response",
                                url: url
                            };
                            dispatch(_this.failure(type, err));
                            reject(err);
                        });
                    }
                    else {
                        response
                            .json()
                            .then(function (data) {
                            err = {
                                status: response.status,
                                response: data.detail,
                                url: url
                            };
                            dispatch(_this.failure(type, err));
                            reject(err);
                        })
                            .catch(function (parseError) {
                            err = {
                                status: response.status,
                                response: "Request failed",
                                url: url
                            };
                            dispatch(_this.failure(type, err));
                            reject(err);
                        });
                    }
                })
                    .catch(function (err) {
                    err = {
                        status: null,
                        response: err.message,
                        url: url
                    };
                    dispatch(_this.failure(type, err));
                    reject(err);
                });
            });
        };
    };
    ActionCreator.prototype.fetchOPDS = function (type, url) {
        var _this = this;
        return function (dispatch) {
            dispatch(_this.request(type, url));
            return new Promise(function (resolve, reject) {
                _this.fetcher
                    .fetchOPDSData(url)
                    .then(function (data) {
                    dispatch(_this.success(type));
                    dispatch(_this.load(type, data, url));
                    resolve(data);
                })
                    .catch(function (err) {
                    dispatch(_this.failure(type, err));
                    reject(err);
                });
            });
        };
    };
    ActionCreator.prototype.request = function (type, url) {
        return { type: "".concat(type, "_").concat(ActionCreator.REQUEST), url: url };
    };
    ActionCreator.prototype.success = function (type) {
        return { type: "".concat(type, "_").concat(ActionCreator.SUCCESS) };
    };
    ActionCreator.prototype.failure = function (type, error) {
        return { type: "".concat(type, "_").concat(ActionCreator.FAILURE), error: error };
    };
    ActionCreator.prototype.load = function (type, data, url) {
        return { type: "".concat(type, "_").concat(ActionCreator.LOAD), data: data, url: url };
    };
    ActionCreator.prototype.clear = function (type) {
        return { type: "".concat(type, "_").concat(ActionCreator.CLEAR) };
    };
    ActionCreator.prototype.fetchCollection = function (url) {
        return this.fetchOPDS(ActionCreator.COLLECTION, url);
    };
    ActionCreator.prototype.fetchPage = function (url) {
        return this.fetchOPDS(ActionCreator.PAGE, url);
    };
    ActionCreator.prototype.fetchBook = function (url) {
        return this.fetchOPDS(ActionCreator.BOOK, url);
    };
    ActionCreator.prototype.fetchSearchDescription = function (url) {
        var _this = this;
        return function (dispatch) {
            return new Promise(function (resolve, reject) {
                _this.fetcher
                    .fetchSearchDescriptionData(url)
                    .then(function (data) {
                    dispatch(_this.load(ActionCreator.SEARCH_DESCRIPTION, data, url));
                    resolve(data);
                })
                    .catch(function (err) { return reject(err); });
            });
        };
    };
    ActionCreator.prototype.clearCollection = function () {
        return this.clear(ActionCreator.COLLECTION);
    };
    ActionCreator.prototype.closeError = function () {
        return { type: ActionCreator.CLOSE_ERROR };
    };
    ActionCreator.prototype.loadBook = function (data, url) {
        return this.load(ActionCreator.BOOK, data, url);
    };
    ActionCreator.prototype.clearBook = function () {
        return this.clear(ActionCreator.BOOK);
    };
    ActionCreator.prototype.updateBook = function (url) {
        return this.fetchOPDS(ActionCreator.UPDATE_BOOK, url);
    };
    ActionCreator.prototype.fulfillBook = function (url) {
        return this.fetchBlob(ActionCreator.FULFILL_BOOK, url);
    };
    ActionCreator.prototype.indirectFulfillBook = function (url, type) {
        var _this = this;
        return function (dispatch) {
            return new Promise(function (resolve, reject) {
                dispatch(_this.request(ActionCreator.FULFILL_BOOK, url));
                _this.fetcher
                    .fetchOPDSData(url)
                    .then(function (book) {
                    var _a;
                    var link = (_a = book.fulfillmentLinks) === null || _a === void 0 ? void 0 : _a.find(function (link) { return link.type === type; });
                    if (link) {
                        dispatch(_this.success(ActionCreator.FULFILL_BOOK));
                        resolve(link.url);
                    }
                    else {
                        throw {
                            status: 200,
                            response: "Couldn't fulfill book",
                            url: url
                        };
                    }
                })
                    .catch(function (err) {
                    dispatch(_this.failure(ActionCreator.FULFILL_BOOK, err));
                    reject(err);
                });
            });
        };
    };
    ActionCreator.prototype.fetchLoans = function (url) {
        return this.fetchOPDS(ActionCreator.LOANS, url);
    };
    ActionCreator.prototype.showAuthForm = function (callback, cancel, providers, title, error, attemptedProvider) {
        var flattenedProviders = (0, auth_1.flattenSamlProviders)(providers);
        return {
            type: ActionCreator.SHOW_AUTH_FORM,
            callback: callback,
            cancel: cancel,
            providers: flattenedProviders,
            title: title,
            error: error,
            attemptedProvider: attemptedProvider
        };
    };
    ActionCreator.prototype.closeErrorAndHideAuthForm = function () {
        var _this = this;
        return function (dispatch) {
            dispatch(_this.closeError());
            dispatch(_this.hideAuthForm());
        };
    };
    ActionCreator.prototype.hideAuthForm = function () {
        return { type: ActionCreator.HIDE_AUTH_FORM };
    };
    ActionCreator.prototype.saveAuthCredentials = function (credentials) {
        this.fetcher.setAuthCredentials(credentials);
        return { type: ActionCreator.SAVE_AUTH_CREDENTIALS, credentials: credentials };
    };
    ActionCreator.prototype.clearAuthCredentials = function () {
        this.fetcher.clearAuthCredentials();
        return { type: ActionCreator.CLEAR_AUTH_CREDENTIALS };
    };
    ActionCreator.prototype.setPreference = function (key, value) {
        return { type: ActionCreator.SET_PREFERENCE, key: key, value: value };
    };
    ActionCreator.REQUEST = "REQUEST";
    ActionCreator.SUCCESS = "SUCCESS";
    ActionCreator.FAILURE = "FAILURE";
    ActionCreator.LOAD = "LOAD";
    ActionCreator.CLEAR = "CLEAR";
    ActionCreator.COLLECTION = "COLLECTION";
    ActionCreator.PAGE = "PAGE";
    ActionCreator.BOOK = "BOOK";
    ActionCreator.SEARCH_DESCRIPTION = "SEARCH_DESCRIPTION";
    ActionCreator.UPDATE_BOOK = "UPDATE_BOOK";
    ActionCreator.FULFILL_BOOK = "FULFILL_BOOK";
    ActionCreator.LOANS = "LOANS";
    ActionCreator.COLLECTION_REQUEST = "COLLECTION_REQUEST";
    ActionCreator.COLLECTION_SUCCESS = "COLLECTION_SUCCESS";
    ActionCreator.COLLECTION_FAILURE = "COLLECTION_FAILURE";
    ActionCreator.COLLECTION_LOAD = "COLLECTION_LOAD";
    ActionCreator.COLLECTION_CLEAR = "COLLECTION_CLEAR";
    ActionCreator.PAGE_REQUEST = "PAGE_REQUEST";
    ActionCreator.PAGE_SUCCESS = "PAGE_SUCCESS";
    ActionCreator.PAGE_FAILURE = "PAGE_FAILURE";
    ActionCreator.PAGE_LOAD = "PAGE_LOAD";
    ActionCreator.BOOK_REQUEST = "BOOK_REQUEST";
    ActionCreator.BOOK_SUCCESS = "BOOK_SUCCESS";
    ActionCreator.BOOK_FAILURE = "BOOK_FAILURE";
    ActionCreator.BOOK_LOAD = "BOOK_LOAD";
    ActionCreator.BOOK_CLEAR = "BOOK_CLEAR";
    ActionCreator.SEARCH_DESCRIPTION_LOAD = "SEARCH_DESCRIPTION_LOAD";
    ActionCreator.CLOSE_ERROR = "CLOSE_ERROR";
    ActionCreator.UPDATE_BOOK_REQUEST = "UPDATE_BOOK_REQUEST";
    ActionCreator.UPDATE_BOOK_SUCCESS = "UPDATE_BOOK_SUCCESS";
    ActionCreator.UPDATE_BOOK_FAILURE = "UPDATE_BOOK_FAILURE";
    ActionCreator.UPDATE_BOOK_LOAD = "UPDATE_BOOK_LOAD";
    ActionCreator.FULFILL_BOOK_REQUEST = "FULFILL_BOOK_REQUEST";
    ActionCreator.FULFILL_BOOK_SUCCESS = "FULFILL_BOOK_SUCCESS";
    ActionCreator.FULFILL_BOOK_FAILURE = "FULFILL_BOOK_FAILURE";
    ActionCreator.LOANS_REQUEST = "LOANS_REQUEST";
    ActionCreator.LOANS_SUCCESS = "LOANS_SUCCESS";
    ActionCreator.LOANS_FAILURE = "LOANS_FAILURE";
    ActionCreator.LOANS_LOAD = "LOANS_LOAD";
    ActionCreator.SHOW_AUTH_FORM = "SHOW_AUTH_FORM";
    ActionCreator.HIDE_AUTH_FORM = "HIDE_AUTH_FORM";
    ActionCreator.SAVE_AUTH_CREDENTIALS = "SAVE_AUTH_CREDENTIALS";
    ActionCreator.CLEAR_AUTH_CREDENTIALS = "CLEAR_AUTH_CREDENTIALS";
    ActionCreator.SET_PREFERENCE = "SET_PREFERENCE";
    return ActionCreator;
}());
exports.default = ActionCreator;
